#include <dlfcn.h>

#include "trampoline.h"
#include "memory.h"
#include "log.h"

// Run Trampoline
typedef uint32_t (*trampoline_t)(typeof(memory_writer) *writer, uint32_t id, const unsigned char *args);
static trampoline_t func = nullptr;
uint32_t trampoline(uint32_t id, const unsigned char *args) {
    return func(memory_writer, id, args);
}

// Init
void init_trampoline() {
    static bool is_setup = false;
    if (is_setup) {
        return;
    }
    is_setup = true;
    // Open Library
    void *handle = dlopen("libmedia-layer-trampoline.so", RTLD_NOW);
    if (handle != nullptr) {
        func = (trampoline_t) dlsym(handle, "trampoline");
    }
    if (func == nullptr) {
        ERR("Unable To Load Media Layer Trampoline: %s", dlerror());
    }
}